diff mbox series

[v2,2/2] rtld: Add test case for '--' option

Message ID 20240726103351.3956251-2-henrik@lxm.se
State New
Headers show
Series None | expand

Commit Message

Henrik Lindström July 26, 2024, 10:33 a.m. UTC
---
 elf/Makefile              |  7 +++++++
 elf/tst-rtld-dash-dash.sh | 41 +++++++++++++++++++++++++++++++++++++++
 2 files changed, 48 insertions(+)
 create mode 100644 elf/tst-rtld-dash-dash.sh

Comments

Adhemerval Zanella Netto July 30, 2024, 4:40 p.m. UTC | #1
LGTM, thanks.

Reviewed-by: Adhemerval Zanella  <adhemerval.zanella@linaro.org>

On 26/07/24 07:33, Henrik Lindström wrote:
> ---
>  elf/Makefile              |  7 +++++++
>  elf/tst-rtld-dash-dash.sh | 41 +++++++++++++++++++++++++++++++++++++++
>  2 files changed, 48 insertions(+)
>  create mode 100644 elf/tst-rtld-dash-dash.sh
> 
> diff --git a/elf/Makefile b/elf/Makefile
> index a3475f3fb5..68444e88d9 100644
> --- a/elf/Makefile
> +++ b/elf/Makefile
> @@ -630,6 +630,13 @@ $(objpfx)tst-rtld-does-not-exist.out: tst-rtld-does-not-exist.sh $(objpfx)ld.so
>  	$(SHELL) $< $(objpfx)ld.so > $@; \
>  	$(evaluate-test)
>  
> +ifeq ($(run-built-tests),yes)
> +tests-special += $(objpfx)tst-rtld-dash-dash.out
> +endif
> +$(objpfx)tst-rtld-dash-dash.out: tst-rtld-dash-dash.sh $(objpfx)ld.so
> +	$(SHELL) $< $(objpfx)ld.so > $@; \
> +	$(evaluate-test)
> +
>  tests += $(tests-execstack-$(have-z-execstack))
>  ifeq ($(run-built-tests),yes)
>  tests-special += \
> diff --git a/elf/tst-rtld-dash-dash.sh b/elf/tst-rtld-dash-dash.sh
> new file mode 100644
> index 0000000000..2bc1f85598
> --- /dev/null
> +++ b/elf/tst-rtld-dash-dash.sh
> @@ -0,0 +1,41 @@
> +#!/bin/sh
> +# Test for the '--' option in ld.so.
> +# Copyright (C) 2024 Free Software Foundation, Inc.
> +# This file is part of the GNU C Library.
> +
> +# The GNU C Library is free software; you can redistribute it and/or
> +# modify it under the terms of the GNU Lesser General Public
> +# License as published by the Free Software Foundation; either
> +# version 2.1 of the License, or (at your option) any later version.
> +
> +# The GNU C Library is distributed in the hope that it will be useful,
> +# but WITHOUT ANY WARRANTY; without even the implied warranty of
> +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
> +# Lesser General Public License for more details.
> +
> +# You should have received a copy of the GNU Lesser General Public
> +# License along with the GNU C Library; if not, see
> +# <https://www.gnu.org/licenses/>.
> +
> +export LC_ALL=C
> +
> +# --inhibit-cache to suppress "No such file or directory" message when
> +# /etc/ld.so.cache does not exist.
> +rtld="$1 --inhibit-cache"
> +tmp_out="$(mktemp)"
> +
> +$rtld -- --program-does-not-exist 2>"$tmp_out"
> +status=$?
> +echo "$rtld exit status: $status"
> +echo "output (with expected error):"
> +cat "$tmp_out"
> +
> +if test $status -eq 127 \
> +	&& grep -q "^--program-does-not-exist: error while loading shared libraries: --program-does-not-exist: cannot open shared object file$" "$tmp_out" \
> +	&& test "$(wc -l < "$tmp_out")" -eq 1 ; then
> +    status=0
> +else
> +    status=1
> +fi
> +rm "$tmp_out"
> +exit $status
diff mbox series

Patch

diff --git a/elf/Makefile b/elf/Makefile
index a3475f3fb5..68444e88d9 100644
--- a/elf/Makefile
+++ b/elf/Makefile
@@ -630,6 +630,13 @@  $(objpfx)tst-rtld-does-not-exist.out: tst-rtld-does-not-exist.sh $(objpfx)ld.so
 	$(SHELL) $< $(objpfx)ld.so > $@; \
 	$(evaluate-test)
 
+ifeq ($(run-built-tests),yes)
+tests-special += $(objpfx)tst-rtld-dash-dash.out
+endif
+$(objpfx)tst-rtld-dash-dash.out: tst-rtld-dash-dash.sh $(objpfx)ld.so
+	$(SHELL) $< $(objpfx)ld.so > $@; \
+	$(evaluate-test)
+
 tests += $(tests-execstack-$(have-z-execstack))
 ifeq ($(run-built-tests),yes)
 tests-special += \
diff --git a/elf/tst-rtld-dash-dash.sh b/elf/tst-rtld-dash-dash.sh
new file mode 100644
index 0000000000..2bc1f85598
--- /dev/null
+++ b/elf/tst-rtld-dash-dash.sh
@@ -0,0 +1,41 @@ 
+#!/bin/sh
+# Test for the '--' option in ld.so.
+# Copyright (C) 2024 Free Software Foundation, Inc.
+# This file is part of the GNU C Library.
+
+# The GNU C Library is free software; you can redistribute it and/or
+# modify it under the terms of the GNU Lesser General Public
+# License as published by the Free Software Foundation; either
+# version 2.1 of the License, or (at your option) any later version.
+
+# The GNU C Library is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# Lesser General Public License for more details.
+
+# You should have received a copy of the GNU Lesser General Public
+# License along with the GNU C Library; if not, see
+# <https://www.gnu.org/licenses/>.
+
+export LC_ALL=C
+
+# --inhibit-cache to suppress "No such file or directory" message when
+# /etc/ld.so.cache does not exist.
+rtld="$1 --inhibit-cache"
+tmp_out="$(mktemp)"
+
+$rtld -- --program-does-not-exist 2>"$tmp_out"
+status=$?
+echo "$rtld exit status: $status"
+echo "output (with expected error):"
+cat "$tmp_out"
+
+if test $status -eq 127 \
+	&& grep -q "^--program-does-not-exist: error while loading shared libraries: --program-does-not-exist: cannot open shared object file$" "$tmp_out" \
+	&& test "$(wc -l < "$tmp_out")" -eq 1 ; then
+    status=0
+else
+    status=1
+fi
+rm "$tmp_out"
+exit $status